unit WebModuleUnit1;

interface

uses
  System.SysUtils, System.Classes, Web.HTTPApp, GraphQL.ParamTest,
  GraphQL.Schema, GraphQL.WebBroker, GraphQL.Comp.Schema;

type
  TWebModule1 = class(TWebModule)
    GraphQLSchema1: TGraphQLSchema;
    GraphQLWebBrokerDispatcher1: TGraphQLWebBrokerDispatcher;
    procedure WebModule1DefaultHandlerAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure GraphQLSchema1InitSchema(Sender: TObject;
      Schema: TSchemaDocument);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TWebModule1.GraphQLSchema1InitSchema(Sender: TObject;
  Schema: TSchemaDocument);
begin
  Schema.Bind('Query', TQuery);
  Schema.Bind('Customer', TCustomer);
  // todo: mutations can be binded here when there are any in the schema
end;

procedure TWebModule1.WebModule1DefaultHandlerAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  Response.Content :=
    '<html>' +
    '<head>' +
    '<title>GraphQL endpoint</title>' +
    '</head>' +
    '<body>' +
    '<h1>GraphQL endpoint - Welcome!</h1>' +
    '<p>Click <a href="http://localhost:8080/graphql/">here</a> for playground.</p>' +
    '</body>' +
    '</html>';
end;

end.


